LTC = {};

---------
function LTC:OnLoad()
---------
	SLASH_LOST_TREASURE_CHECK1 = "/ltc";
	SlashCmdList["LOST_TREASURE_CHECK"] = function(msg) LTC:HandleSlashCommand(msg) end

	LTCFrame:RegisterEvent("PLAYER_LOGIN")
	LTCFrame:RegisterEvent("ADDON_LOADED")
end

---------
function LTC:OnEvent(self, event, ...)
---------
	local arg1, arg2, arg3, arg4 = ...
	if event == "ADDON_LOADED" and arg1 == "Lost Treasure Check" then
		LTCFrame:UnregisterEvent("ADDON_LOADED");
	elseif event == "PLAYER_LOGIN" then
		LTC:LoadItems();
		LTC:LoadedNotify();
	end
end

---------
function LTC:LoadItems()
	LTC_items = {
		["31402"] = "Ancient Jinyu Staff",
		["31284"] = "Ancient Pandaren Fishing Charm",
		["31399"] = "Ancient Pandaren Mining Pick",
		["31292"] = "Ancient Pandaren Woodcutter",
		["31438"] = "Blade of the Poisoned Mind",
		["31433"] = "Blade of the Prime",
		["31436"] = "Bloodsoaked Chitin Fragment",
		["31406"] = "Cache of Pilfered Goods",
		["31435"] = "Dissector's Staff of Mutation",
		["31410"] = "Equipment Locker",
		["31403"] = "Hammer of Ten Thunders",
		["31413"] = "Hozen Warrior Spear",
		["31307"] = "Jade Infused Blade",
		["31304"] = "Kafa Press",
		["31431"] = "Lucid Amulet of the Agile Mind",
		["31430"] = "Malik's Stalwart Spear",
		["31432"] = "Manipulator's Talisman",
		["31409"] = "Pandaren Fishing Spear",
		["31411"] = "Recipe: Banana Infused Rum",
		["31412"] = "Sprite's Cloth Chest",
		["31407"] = "Staff of the Hidden Master",
		["31421"] = "Sturdy Yaungol Spear",
		["31437"] = "Swarmkeeper's Medallion",
		["31434"] = "Swarming Cleaver of Ka'roz",
		["31417"] = "Tablet of Ren Yun",
		["31429"] = "Wind-Reaver's Dagger of Quick Strikes",
		["31397"] = "Wodin's Mantid Shanker",
		["31425"] = "Yaungol Fire Carrier"
	}
	table.sort(LTC_items);
	LTC_total = LTC:CountItems();
end

---------
function LTC:LoadedNotify(self)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."LostTreasureCheck |rloaded "..GREEN_FONT_COLOR_CODE..LTC_total.."|r items.");
end

---------
function LTC:HandleSlashCommand(cmd)
---------
	if string.lower(cmd) == "all" then
		LTC:CheckItems(true);
	else
		LTC:CheckItems(false);
	end
end

---------
function LTC:CountItems()
---------
	local count = 0;
	for _ in pairs(LTC_items)
	do
		count = count + 1;
	end
	return count;
end

---------
function LTC:CheckItems(showAll)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: |r");
	DEFAULT_CHAT_FRAME:AddMessage("---------------------------|r");
	if LTC_items then
		local completed = 0;
		for key,val in pairs(LTC_items)
		do
			local isCompleted = IsQuestFlaggedCompleted(key);
			if isCompleted == 1 then
				completed = completed + 1;
				if showAll then
					DEFAULT_CHAT_FRAME:AddMessage(val..": "..GREEN_FONT_COLOR_CODE.."Yes |r");
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage(val..": "..RED_FONT_COLOR_CODE.."No |r");
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Completed: |r"..completed.."/"..LTC_total);
	end
end